/** Lab 7 SO - Memoria virtuala */
/** Demo Linux */

#include <sys/mman.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

static int pagesize;

void message() {
	printf("Print me\n");
}

int main() {
	void *addr, *addr_aligned;

	pagesize = getpagesize();

	// adresa functiei
	addr = &message;
	printf("adresa functiei %p\n",addr);

	// aliniere adresa a multiplu de pagina
	addr_aligned = (void*)((int)addr - ((int)addr)%pagesize);
	printf("adresa paginii ce contine functia %p\n",addr_aligned);

	// pid
	printf("process id %i\n", getpid());

	// schimbare protectie pagina
	mprotect(addr_aligned, pagesize, PROT_NONE);

	// apel functie
	message();

	return 0;
}
